function W = computeW (X1, X2, Y1, Y2, theta)
	[p1,n1] = size(X1);
	[p2,n2] = size(X2);
	if p1 ~= p2
		error('X1 and X2 should have same number of columns');
	end
	p = p1;

	% Compute mean matrices
	M1 = repmat(mean(Y1, 2), 1, n1);
	M2 = repmat(mean(Y2, 2), 1, n2);

	% Compute W
	W = (Y1 - M1)*(Y1 - M1)' + (Y2 - M2)*(Y2 - M2)';

	global ALPHA;
	W = (1 - ALPHA) * W + ALPHA * eye(size(W));
end
