function dConvdthetaMtx = computedConvdthetaMtx (X, theta, i)
% dConvdthetaMtx = COMPUTEDCONVDTHETAMTX (X, theta) computes the derivative with respect to theta
% of convolveAll(X, theta).

	m = sqrt(length(theta));
	n = sqrt(size(X, 1));
	idxs = reshape(1:length(theta), [ m m ]);
	[r,c] = find(idxs == i);

	% PRECOMPUTE how to trim the matrix back down to only be the "center" part
	% of the convolution result.
	upperPadding = ceil((m+n-1 - n) / 2);
	leftPadding = ceil((m+n-1 - n) / 2);
	lowerPadding = m+n-1 - n - upperPadding;
	rightPadding = m+n-1 - n - leftPadding;
	vertIdxs = 1+upperPadding:m+n-1-lowerPadding;
	horzIdxs = 1+leftPadding:m+n-1-rightPadding;

	% Pre-compute an "index" matrix that "selects" elements of each column of X.
	I = 1:size(X, 1);
	Iim = reshape(I, [ n n ]);
	dConvdtheta = zeros(size(X));
	dConvdthetaIim = zeros(m+n-1, m+n-1);
	dConvdthetaIim(r:r+n-1, c:c+n-1) = Iim;
	dConvdthetaIimTrim = dConvdthetaIim(vertIdxs, horzIdxs);
	dConvdthetaI = dConvdthetaIimTrim(:);
	A = zeros(size(X, 1), size(X, 1));
	for i = 1:length(I)
		idx = dConvdthetaI(i);
		if idx ~= 0
			A(i,idx) = 1;
		end
	end
	dConvdthetaMtx = A;
end
