function [ f, dfdtheta ] = computef (theta, X1a, X0a, X1b, X0b);
% Learns a filter parameterized by theta that will tend to suppress
% discriminability of Task A and preserve discriminability of Task B.
	REGULARIZER = 1e0;

	Y1a = convolveAll(X1a, theta);
	Y0a = convolveAll(X0a, theta);
	Y1b = convolveAll(X1b, theta);
	Y0b = convolveAll(X0b, theta);
	Wa = computeW(X1a, X0a, Y1a, Y0a, theta);
	Wb = computeW(X1b, X0b, Y1b, Y0b, theta);
	
	theta
	f1 = computeDlda(X1a, X0a, Y1a, Y0a, Wa, theta)
	f2 = computeDlda(X1b, X0b, Y1b, Y0b, Wb, theta)
	f = log(f1) - log(f2) + REGULARIZER * 1/2 * theta' * theta
	for i = 1:length(theta)
		dfdtheta(i) = computedDldadtheta(X1a, X0a, Y1a, Y0a, Wa, theta, i) / f1 - computedDldadtheta(X1b, X0b, Y1b, Y0b, Wb, theta, i) / f2;
	end
	dfdtheta = dfdtheta' + REGULARIZER * theta;

	show(X1a, X0a, Y1a, Y0a, theta, 1, 1);
	show(X1b, X0b, Y1b, Y0b, theta, 2, 1);
	pause(0.3);
end
