function quilt = make_montage (the_images, numRows, numCols, scaleFactor)
% MAKE_MONTAGE (the_images) makes a montage of numRows x numCols zero-mean, unit-std the_images
  width = size(the_images, 1);

  num_the_images = size(the_images, 3);
  % Subtract mean, and make unit variance
  for i = 1:num_the_images
	the_images(:,:,i) = the_images(:,:,i) - mean2(the_images(:,:,i));
	the_images(:,:,i) = the_images(:,:,i) ./ std2(the_images(:,:,i));
  end

  % Create montage of photos
  quilt = zeros(numRows*width*scaleFactor, numCols*width*scaleFactor);
  i = 1;
  for r = 1:numRows
	ur = (r-1)*width*scaleFactor + 1;
	lr = r*width*scaleFactor;
	for c = 1:numCols
	  uc = (c-1)*width*scaleFactor + 1;
	  lc = c*width*scaleFactor;
	  quilt(ur:lr, uc:lc) = imresize(the_images(:,:,i), scaleFactor, 'bicubic');
	  i = i + 1;
	end
  end
end
